{ Piotr Skowronek, Luty 1996.
  skylark@wizard.ae.krakow.pl
}

{$N+,E+,G+}         { 287 Koprocesor i emulacja }
program Fractals_10_beta_cursors;   { With Mouse Support }
                                    {  The Best Version  }
uses crt,graph;
const   path                    = 'c:\bp\bgi';
var     x,y,a,b,c               : real;
        ch                      : char;
        xm,ym,xmouse,ymouse     : integer;
        xturtle,yturtle         : integer;
        kolor,fraktal,zmienne   : byte;
        z                       : word;
        jaki_frac               : string[30];
        czysc,czytac            : boolean;

procedure koniec;                                       { Proc do wyjscia }
var x,y : integer;
begin
setviewport(0,0,getmaxx,getmaxy,clipon);
x:=getmaxx;
setcolor(black);
for y:=0 to getmaxy div 2 do
line(0,y*2,x,y*2);
for y:=getmaxy div 2 downto 0 do
line(0,y*2+1,x,y*2+1);
CloseGraph;
restorecrtmode;
textbackground(red);
textcolor(lightgray);
clreol;
writeln(' Thanx 4 using Fractals 1.0 beta');
normvideo;
halt(0);
end;

               (******** Mouse support's procedures ********)
procedure hide_mouse; assembler;                              { <--- Ukrycie }
asm
mov ax,2
int 33h
end;
procedure show_mouse; assembler;                              { <----- Pokaz }
asm
mov ax,1
int 33h
end;
procedure init_mouse; assembler;                             { <- Init mousa }
asm
mov ax,0     { Init }
int 33h
mov ax,1     { Show }
int 33h
mov ax,04h   { Ustawienie poz na cx,dx }
mov cx,600
mov dx,200
int 33h
end;
function mouse_in:word;         { Func zapisuje polozenie mousa po }
var w: word;                    { wcisnieciu, i czy nacisnieto     }
begin
asm
mov ax,05h                      { int $33 fun $05 odczyt, bx - key }
mov bx,0h
int 33h
mov xmouse,cx
mov ymouse,dx
mov w,bx
end;
mouse_in:=w;
end;
function mouse_out:word;        { Func zapisuje polozenie mousa po }
var w: word;                    { odcisnieciu, i czy nacisnieto    }
begin
asm
mov ax,05h
mov bx,0h
int 33h
mov xmouse,cx
mov ymouse,dx
mov w,bx
end;
mouse_out:=w;
end;
              (******* End Mouse Support's procedures *******)

                (******** Arrows program control *********)
function kursory(numerm,maxkolej:byte):byte;            { Proc wybierania }
var xmin,ymin,xmax,ymax,i : integer;
    koniecb : boolean;
    s     : string;

procedure abc_values;
var okno : pointer;
    s    : string;
begin
getmem(okno,imagesize(0,0,300,150));
setviewport(0,0,639,479,true);
getimage   (170,165,470,315,okno^);
setcolor   (yellow);
setviewport(170,165,470,315,true);
hide_mouse;
clearviewport;
rectangle(0,0,300,150);
setcolor(black);
outtextxy(127,7,'');
setcolor(lightblue);
outtextxy(25,140,'Press eny key or strike mouse...');
outtextxy(127,7,' Value');
outtextxy(15,40,'Formula : '+jaki_frac);
setcolor(green);

if fraktal<>6 then begin
if zmienne>0 then begin str(a,s); outtextxy(15,60,'a='+s); end;
if zmienne>1 then begin str(b,s); outtextxy(15,70,'b='+s); end;
if zmienne>2 then begin str(c,s); outtextxy(15,80,'c='+s); end;
if zmienne=0 then begin str(round(a),s); outtextxy(15,60,'step='+s);
if fraktal=7 then begin str(round(b),s); outtextxy(15,60,'random value='+s); end;
end;
end
else
outtextxy(15,60,'Special case');
str(z,s);
s:='zoom='+s;
if z=1 then s:='zoom= none';
outtextxy(15,90,s);
setviewport(0,0,639,479,true);
show_mouse;
repeat until (keypressed) or (mouse_out<>0);
{if keypressed then readkey;}
hide_mouse;
putimage(170,165,okno^,normalput);
show_mouse;
freemem(okno,imagesize(0,0,300,250));
end;

function napis(numer,kolej:byte):string;        { Jakie napisy wyswietlic }
begin
case numer of
1 :       case kolej of   { Menu glowne }
          1 : s:='Options';
          2 : s:='Colors';
          3 : s:='About';
          4 : s:='Exit';
          end;
2 :       case kolej of   { Options }
          1 : s:='Formulas     ';{Clear screen';}
          2 : s:='Change value ';
          3 : s:='Random value';
          4 : s:='Change zoom  ';
          5 : s:='Re-paint';
          6 : s:='Return       '+#17;
          end;
3 :       case kolej of   { Colors }
          1 : s:='Black';
          2 : s:='Blue';
          3 : s:='Green';
          4 : s:='Cyan';
          5 : s:='Red';
          6 : s:='Magenta';
          7 : s:='Brown';
          8 : s:='LightGray';
          9 : s:='DarkGray';
          10: s:='LightBlue';
          11: s:='LightGreen';
          12: s:='LightCyan';
          13: s:='LightRed';
          14: s:='LightMagenta';
          15: s:='Yellow';
          16: s:='White';
          17: s:='Return       '+#17;
          end;
5:        case kolej of    { Zoom }
          1 : s:='None';
          2 : s:='x2';
          3 : s:='x3';
          4 : s:='x4';
          5 : s:='x5';
          6 : s:='x6';
          7 : s:='x7';
          8 : s:='x8';
          9 : s:='x9';
         10 : s:='x10';
         11 : s:='x20';
         12 : s:='x50';
         13 : s:='x100';
         14 : s:='x1000';
          end;
6:        case kolej of    { Dla clear screenow }
          1 : s:='Yes';
          2 : s:='No';
          end;
7:        case kolej of    { Dla formulas }
          1 : s:='Formula #1';
          2 : s:='Formula #2';
          3 : s:='Formula #3';
          4 : s:='Formula #4';
          5 : s:='Formula #5';

          6 : s:='Fern';
          7 : s:='Tree #1';
          8 : s:='Tree #2';
          9 : s:='Tree #2 Rand';
         10 : s:='Koch''s flake';
         11 : s:='Return       '+#17;
          end;
end;
napis:=s;
end;
procedure b;                                     { Aktywne napisy }
begin
setcolor(lightgreen);
end;
procedure c;                                     { Nie aktywne napisy }
begin
setcolor(white);
end;

var pressIn,pressOut : word;
    inew : byte;
begin
show_mouse;
{setviewport(getmaxy+5,270,getmaxx-3,getmaxy-3, clipon);}
setviewport(484,270,636,476, clipon);
clearviewport;
xmin:=getmaxy+5;
ymin:=250;
xmax:=getmaxx-3;
ymax:=10*maxkolej+10;
koniecb:=false;
setviewport(xmin,ymin,xmax,ymax+20,clipon);
b;
xmin:=5;
ymin:=0;
hide_mouse;                            { Zgaszenie kurs zeby nie bylo smieci }
for i:=1 to maxkolej do
outtextxy(xmin,ymin+i*10,napis(numerm,i));
c;
i:=1;
            if czytac=false then begin; czytac:=true;     { Dla menu glwn by }
            SetViewPort(3, 3, 481, 476, ClipOn);  {  wyswietlic  }
            show_mouse;
            exit; end;                                   { a nie czytac keya }

setcolor(white);                                     { Wysw aktual poloz kur }
outtextxy(xmin,ymin+i*10,napis(numerm,i));
show_mouse;

repeat
                  (********  Mouse Support ! *********)
pressOut:=mouse_out;                          { Pobranie ile nacisniec }
pressIn:=mouse_in;                            {   -//-       odcisniec }

if (pressOut=0) and (pressIn=0) then begin        { Gdy nie nacisnieto }
asm
mov ax,03h                                      { Odczyt pozycji mousa }
int 33h
mov xmouse,cx
mov ymouse,dx
end;
end;

if (xmouse>=485) and (xmouse<=636) and
   (ymouse>=  3) and (ymouse<=220) and (pressout<>0) then begin
   abc_values;
   exit;
   end;
if (xmouse>=485) and (xmouse<=625) and            { Okno odczytu myszy }
   (ymouse>=275) and (ymouse<=275+maxkolej*10) then
begin

inew:=trunc((ymouse-280)/10)+1;         { na wsplzedne okienka i "i=?" }
if pressIn<pressOut then koniecb:=true;
if inew<>i then begin                   { gdy nowe i <> od old i       }
      hide_mouse;                       { wtedy wodzenie kur za mysza  }
      b; outtextxy(xmin,ymin+i*10,napis(numerm,i)); i:=inew;
      c; outtextxy(xmin,ymin+i*10,napis(numerm,i));
      show_mouse;
end;
end;

                      (***** Keyboard Support *****)
if keypressed then
begin
  ch:=readkey;
      if ch=#13 then koniecb:=true;
      if ch=#27 then begin koniecb:=true; i:=99; end;
      if ch=#0  then begin ch:=readkey;
      hide_mouse;                     { Zgaszenie kurs zeby nie bylo smieci }
      case ch of
      #80 :  if i+1<=maxkolej then begin                   { Dolna szczalka }
                          b; outtextxy(xmin,ymin+i*10,napis(numerm,i)); inc(i);
                          c; outtextxy(xmin,ymin+i*10,napis(numerm,i)); end;
      #72 :  if i-1>=1        then begin                   { Gorna szczalka }
                          b; outtextxy(xmin,ymin+i*10,napis(numerm,i)); dec(i);
                          c; outtextxy(xmin,ymin+i*10,napis(numerm,i)); end;
      #75 : begin {lewa}  b; outtextxy(xmin,ymin+i*10,napis(numerm,i)); i:=1;
                          c; outtextxy(xmin,ymin+i*10,napis(numerm,i)); end;
      #77 : begin {prawa} b; outtextxy(xmin,ymin+i*10,napis(numerm,i)); i:=maxkolej;
                          c; outtextxy(xmin,ymin+i*10,napis(numerm,i)); end;
      #45 : koniec;                                        { Alt-X }
      #47 : begin abc_values; exit; end;
      end;
asm
mov ax,03h                      { Odczyt pozycji mausa }
int 33h
mov xmouse,cx
mov ymouse,dx
end;
if (xmouse>=485) and (xmouse<=625) then
if (ymouse>=275) and (ymouse<=275+maxkolej*10) then
begin
ymouse:=270+10*i;
asm
mov ax,04h                      { Ustawienie poz na cx,dx }
mov cx,xmouse
mov dx,ymouse
int 33h
end;
end;
      show_mouse;
      end;
end;

until koniecb=true;
kursory:=i;             { Inf dla proc wywolujacej ktora opcja wybrana }
SetViewPort(3, 3, GetMaxy+2, GetMaxY-3, ClipOn);       { Okno fractala }
hide_mouse;
end;

                   (******* Init graph VGA 16 *******)
procedure init;
var st,tr,blad : integer;
begin
randomize;
detectgraph(st,tr);
if st<>9 then begin
textbackground(red);
textcolor(lightgray+blink);
clreol;
writeln('Error! Program works properly only on VGA');
normvideo;
halt(1);
end;
tr:=2;
initgraph(st,tr,path);
blad:=graphresult;
if blad<>0 then begin
writeln;
writeln('Error while initialization graphics mode.');
WRITELN(GRAPHERRORMSG(BLAD));
halt(1);
end;
end;

                          (****** Okno ******)
procedure about;                             { Rys logo i aktualne wartosci }
var s: string[30];
begin
setviewport(484,3,636,476, clipon);
clearviewport;
setcolor(lightblue);
settextstyle(6,horizdir,3);
outtextxy(5,3,'Fractals v1.0b');
setcolor(white);
line(10,38,135,38);
setcolor(lightgreen);
settextstyle(0,horizdir,1);
outtextxy(5,60,'Formula :');
setcolor(green);
outtextxy(7,75,jaki_frac);
setcolor(lightgreen);
outtextxy(5,100,'Variables :');
setcolor(green);                              { Wartosci a,b,c }
if fraktal<>6 then begin
if zmienne>0 then begin str(a,s); outtextxy(7,115,'a='+s); end;
if zmienne>1 then begin str(b,s); outtextxy(7,135,'b='+s); end;
if zmienne>2 then begin str(c,s); outtextxy(7,155,'c='+s); end;
if zmienne=0 then begin str(round(a),s); outtextxy(7,115,'step='+s);
if fraktal=7 then begin str(round(b),s); outtextxy(7,125,'random value='+s); end;
end;
end
else
outtextxy(7,115,'Special case');

str(z,s);
s:='zoom='+s;
if z=1 then s:='zoom= none';
setcolor(lightgreen);
outtextxy(5,185,'Configuration :');
setcolor(green);
outtextxy(7,200,s);
SetViewPort(3, 3, GetMaxy+3, GetMaxY-3, ClipOn);
end;

procedure czysc_okienko;                { Czysci okno status }
begin
setviewport(getmaxy+5,225,getmaxx-3,getmaxy-3, clipon);
clearviewport;
setcolor(white);
line(10,10,135,10);                     { i linia }
setcolor(black);
end;

procedure status(working:boolean);      { Prawe dolne okno STATUS }
begin
czysc_okienko;
outtextxy(50,7,'');
setcolor(lightblue);
outtextxy(50,7,'Status');
setcolor(lightred);
if working=true then                    { Gdy rysuje to }
begin
    outtextxy(5,30,'Counting...');
    czytac:=false;
    kursory(1,4);
end;
if working=false then                   { Gdy nie rysuje to }
begin
    if (fraktal<5) or (fraktal>8) then
    outtextxy(5,30,'Pause...')
    else
    outtextxy(5,30,'Done...');
    czytac:=false;
    kursory(1,4);
end;
SetViewPort(3, 3, GetMaxy+2, GetMaxY-3, ClipOn);
end;

procedure help;
var s: string[30];
begin
czysc_okienko;
outtextxy(46,7,'');
setcolor(lightblue);
outtextxy(46,7,' About');
setcolor(green);
outtextxy(18,60,'Fractals v1.0b');
setcolor(lightred);
outtextxy(22,70,'Author: Piotr');
outtextxy(27,80,' Skowronek');
setcolor(green);
outtextxy(22,95,'  Freeware');
outtextxy(18,105,' 11 Feb 1996');
repeat
until (keypressed) or (mouse_out>0);
if keypressed then ch:=readkey;
status(true);
end;

                        (****** Wybor fractali *******)
procedure formulas;
begin
czysc_okienko;
outtextxy(46,7,'');
setcolor(lightblue);
outtextxy(46,7,'Formulas');
setcolor(green);
czytac:=true;
fraktal:=kursory(7,11);
   case fraktal of
   1,2,5:  zmienne:=3;
   3,4  :  zmienne:=1;
   6    :  zmienne:=6;
   7..10:  zmienne:=0;
   11   :  exit;
   end;
          case fraktal of        { wybranie domyslne wart i nazwe frac }
          1 : begin a:=-3.1415926536;
                    b:=9;
                    c:=1;
                    z:=5;
                    jaki_frac:='Formula #1';
              end;
          2 : begin a:={2.00000000000102;}  -3.1415926536;
                    b:={1.57999999999993;}  9;
                    c:={6.52469999999739;}  1;
                    z:=5;
                    jaki_frac:='Formula #2';
              end;
          3 : begin a:=6.523165660;
                    {b:=3.4656500;
                    c:=6.5399005986;}
                    z:=1;
                    jaki_frac:='Formula #3';
              end;
          4 : begin a:=-0.89287528;
                    z:=3;
                    jaki_frac:='Formula #4';
              end;      { shit }
          5 : begin a:=0.878;
                    b:=-0.479;
                    c:=0.479;
                    jaki_frac:='Formula #5';
                    z:=3;
              end;
          6 : begin jaki_frac:='Fern';
                    z:=5;
              end;
          7 : begin a:=5;
                    z:=5;
                    xturtle:=200;
                    yturtle:=400;
                    jaki_frac:='Tree #1';
              end;
          8 : begin a:=5;
                    z:=5;
                    xturtle:=200;
                    yturtle:=400;
                    jaki_frac:='Tree #2';
              end;
          9 : begin a:=5;
                    b:=30;
                    z:=5;
                    xturtle:=200;
                    yturtle:=400;
                    jaki_frac:='Tree #2 Rand';
              end;
          10 : begin a:=4;
                    z:=5;
                    xturtle:=100;
                    yturtle:=200;
                    jaki_frac:='Koch''s flake';
              end;
          {9 : jaki_frac:='User defined';}
          end;

czysc_okienko;
setcolor(lightgreen);
outtextxy(5,30,'Clear screen ?');       { Czy czyscic ekran ? }
if kursory(6,2)=1 then czysc:=true
else czysc:=false;
x:=1;                    { Liczenie od poczatku }
y:=1;
about;
end;

                       (******* Menu Opcji ********)
procedure options;                             { Proc do robienia okna opcji }
function tab2real:real;   { Funkcja czyta litery z tr graf i zapisuje w real }
var tab : array[1..50] of char;
    i,k : byte;
    l   : string[50];
    r   : real;
    code: integer;
    gc  : integer;
begin
i:=0;
gc:=getcolor;
repeat
repeat
setcolor(yellow);
outtextxy(getx,gety,'_');                   { Emulacja migajacego kursora }
setcolor(black);
delay(90);
outtextxy(getx,gety,'');
setcolor(gc);
delay(80);
until keypressed;
ch:=readkey;
if (ch=#8) and (i>0) then begin         { Backspace }
              begin         { wymazanie }
              {tab[i]:=#0;}   { z cofnieciem o jeden }
              {dec(i);}
              tab[i]:=#0;
              dec(i);
                 if getx-textwidth('8')>=0 then
                 moveto(getx-textwidth('8'),gety)
                 else moveto(0,gety);
              setcolor(black);
              outtext('');
                 if getx-textwidth('8')>=0 then
                 moveto(getx-textwidth('8'),gety)
                 else moveto(0,gety);
              setcolor(green);
              end;
              ch:='~'
              end;
if ch=#13 then begin                       { Gdy enter to koniec }
               {dec(i);}
               ch:='%';
               end;
if (ch<>'%') and (ch<>'~') then begin      { Gdy zadne z powyzszych to }
                  inc(i);
                  tab[i]:=ch;              { wypis na ekran i do tab   }
                  moveto(getx,gety);
                  outtext(ch);
                  end;
if i=50 then ch:='%';
until ch='%';
l:='';
for k:=1 to i do                           { Z tablicy do string a }
l:=l+tab[k];                               { potem do liczby real  }
val(l,r,code);
tab2real:=r;
end;

                        (***** SubProcedures ******)
procedure rand_value;                    { Losuje wartosci a,b,c }
begin
a:=(random(700)-350)/100;
b:=(random(700)-350)/100;
c:=(random(700)-350)/100;
x:=1;
y:=1;
about;
status(true);
czysc:=true;
end;

procedure value;                         { Podproc dla ustalenia a,b,c }
var okno : pointer;
    s    : string;
begin
getmem(okno,imagesize(0,0,300,150));
hide_mouse;
czysc_okienko;
setviewport(0,0,639,479,true);
getimage   (170,165,470,315,okno^);
setcolor   (yellow);
setviewport(170,165,470,315,true);
clearviewport;
rectangle(0,0,300,150);
setcolor(black);
outtextxy(127,7,'');
setcolor(lightblue);
{outtextxy(105,140,#17+'- = Backspace');}
outtextxy(127,7,' Value');
setcolor(lightgreen);
outtextxy(15,30,'Formula : '+jaki_frac);
setcolor(green);
if fraktal<>6 then begin
if zmienne>0 then begin str(a,s); outtextxy(15,45,'a='+s); end;
if zmienne>1 then begin str(b,s); outtextxy(15,55,'b='+s); end;
if zmienne>2 then begin str(c,s); outtextxy(15,65,'c='+s); end;
if zmienne=0 then begin str(round(a),s); outtextxy(15,45,'step='+s);
if fraktal=7 then begin str(round(b),s); outtextxy(15,45,'random value='+s); end;
end;
end
else
outtextxy(15,45,'Special case');

show_mouse;
setcolor(lightgreen);
if fraktal<>6 then begin
outtextxy(15,85,'Enter value for');      { Wpisanie wart. dla a,b,c }
                                        { przy pomocy "tab2real"   }
setcolor(green);
outtextxy(15,100,'a=');
moveto(35,100);
a:=tab2real;
   if (fraktal<>7) and (fraktal<>8) and (fraktal<>10) and (fraktal<>4)
   then begin
outtextxy(15,110,'b=');
moveto(35,110);                          { Ustawienie kursora }
b:=tab2real;                            { proc czyta do TAB potem na Real }
   if (fraktal<>9) then begin
outtextxy(15,120,'c=');
moveto(35,120);
c:=tab2real;
   end;                   { END dla IF FRAKTAL<>7 }
   end;                   { END dla IF FRAKTAL<>5 i <>6 i <>8}
czysc_okienko;
setcolor(lightgreen);
outtextxy(5,30,'Clear screen ?');       { Czy czyscic ekran ? }
if kursory(6,2)=1 then czysc:=true
else czysc:=false;
x:=1;                    { Liczenie od poczatku }
y:=1;
end;                     { END dla IF FRAKTAL<>4 }
setviewport(0,0,639,479,true);
hide_mouse;
putimage(170,165,okno^,normalput);
show_mouse;
freemem(okno,imagesize(0,0,300,250));
about;
status(true);            { True - tzn liczy, false - pauzuje }
end;

procedure zoom;
var t : integer;
begin
czysc_okienko;
outtextxy(46,7,'');
setcolor(lightgreen);
outtextxy(46,7,' Zoom');
czytac:=true;
z:=kursory(5,14);
case z of
11 : z:=20;
12 : z:=50;
13 : z:=100;
14 : z:=1000;
end;
czysc_okienko;                           { Czysci okno status }
setcolor(lightgreen);
outtextxy(15,30,'Clear screen ?');       { Czy czyscic ekran ? }
czytac:=true;
if kursory(6,2)=1 then czysc:=true       { Menu Yes or No }
else czysc:=false;
x:=1;                    { Liczenie od poczatku }
y:=1;
about;
status(true);            { True - tzn liczy, false - pauzuje }
end;
                   (***** END SubProcedures *****)


                     (***** Main OPTIONS ******)
begin
czysc_okienko;                                         { Czysci okno status }
outtextxy(46,7,'');
setcolor(lightblue);
outtextxy(46,7,'Options');
czytac:=true;
                 (****** Procedury do numerow *****)
case kursory(2,6) of
1 : formulas;                                                 { Wyb. wzorow }
2 : value;                                 { Proc ustala wartosci dla a,b,c }
3 : rand_value;                                         { j.w. tylko random }
4 : zoom;                                                    { Powiekszanie }
5 : begin x:=1; y:=1; czysc:=true; ch:='%' end;  {       Wyczyszczenie okna }
255: ch:='%';                                  { 255-gdy wyjscie do gl menu }
end;
SetViewPort(3, 3, GetMaxy+2, GetMaxY-3, ClipOn);  { Ustalenie okna fractala }
status(true);
end;
                     (***** End Options ******)

procedure colors;                                 { Proc wybierania kolorow }
var c: byte;
begin
czysc_okienko;
outtextxy(50,7,'');
setcolor(lightblue);
outtextxy(50,7,'Colours');
czytac:=true;
c:=kursory(3,17)-1;
if c<>16 then
kolor:=c;
status(true);
end;

(*procedure pause;                                        { Zatrzymanie akcji }
begin
status(false);       >> Wylaczone bo bezsensu <<
czytac:=true;
case kursory(4,2) of
1 : begin status(true); exit; end;     { Kontynuacja }
2 : koniec;
end;
status(true);
end;  *)

(************************** Main paint procedures ***************************)
procedure rysuj_fraktal(frac : byte);
                   (***** 1st proc, wg wzoru *****)
procedure f1;                                           { 1st proc, wg wzoru }
var nx,ny: real;
begin
repeat
{a :=pi*pi;}
{nx:= y - sin(x);}
nx:=y-sqrt(abs(b*x-c));
ny:=a-x;
x := nx;
y := ny;
PutPixel(xm+Round(x*z),ym-Round(y*z),kolor);
Until (keypressed) or (mouse_out>0);
end;

                   (***** 2nd proc, wg wzoru *****)
procedure f2;
var nx,ny: real;
begin
repeat
nx:=y-abs(x)/x*sqrt(abs(b*x-c));
ny:=a-x;
x := nx;
y := ny;
PutPixel(xm+Round(x*z),ym-Round(y*z),kolor);
Until (keypressed) or (mouse_out>0);
end;

                   (***** 3rd proc, wg wzoru *****)
procedure f3;
var nx,ny: real;
begin
repeat
nx:= y - sin(x);
ny:=a-x;
x := nx;
y := ny;
PutPixel(xm+Round(x*z),ym-Round(y*z),kolor);
Until (keypressed) or (mouse_out>0);
end;

procedure f4;
  function wzor(xx: real) : real;
  begin
  wzor:=a*xx+(2*(1-a)*xx*xx)/(1+xx*xx);
  end;
var nx,ny : real;
begin
repeat
nx:=y+wzor(x);
ny:=-x+wzor(nx);
x :=nx;
y :=ny;
putpixel(round(x*z)+xm,round(y*z)+ym,kolor);
Until (keypressed) or (mouse_out>0);
end;

procedure f5;
var nx,ny,d,e,f : real;
begin
d:=0.878;
e:=0;
f:=0;
repeat
nx := (a * x) + (b * y) + e;
ny := (c * x) + (d * y) + f;
x := nx;
y := ny;
PutPixel(xm+Round(x*z),ym-Round(y*z),kolor);
Until (keypressed) or (mouse_out>0);
end;

                     (***** 6th proc, paproc *****)
procedure paproc;
var     a,b,c,d,e,f,r,nx,ny : real;
        z1,z2 : byte;
begin
z1:=z*10;
z2:=z*20 div 3;
repeat
r := Random(100);
if (r <= 1) then begin
a := 0; b := 0; c := 0; d := 0.16; e := 0; f := 0; end;
if (r >  1) and (R <= 86) then begin
a := 0.85; b := 0.04; c := -0.04; d := 0.85; e := 0; f := 1.6; end;
if (r > 86) and (r <= 93) then begin
a := 0.2; b := -0.26; c := 0.23; d := 0.22; e := 0; f := 1.6; end;
if (R > 93) and (R <=100) then begin
a := -0.15; b := 0.28; c := 0.26; d := 0.24; e := 0; f := 0.44; end;
nx := (a * x) + (b * y) + e;
ny := (c * x) + (d * y) + f;
x := nx;
y := ny;
PutPixel(xm+round(x*z1),ym+200-round(y*z2),kolor);
Until (keypressed) or (mouse_out>0);
end;

(*************** SubProcedure to construct Turtle graphics ******************)
procedure turtle_graph;
var k,i,l,s:integer;
    heading,xcor,ycor:real;
    {pisac : boolean;}
procedure pw(a:real);
begin
heading:=heading-a;
end;
procedure lw(a:real);
begin
heading:=heading+a;
end;
procedure np(l:real);
var x1,y1 : integer;
begin
x1:=round(xcor);
y1:=round(ycor);
xcor:=xcor+l*cos(heading*0.01745329251994); { <-- Xcor:=xcor+l*cos(heading*pi/180); }
ycor:=ycor+l*sin(heading*0.01745329251994); { <-- ycor:=ycor+l*sin(heading*pi/180); }
line(x1,y1,round(xcor),round(ycor));
end;
procedure ws(l:real);
var x1,y1 : integer;
begin
l:=-l;
x1:=round(xcor);
y1:=round(ycor);
xcor:=xcor+l*cos(heading*0.01745329251994); { <-- Xcor:=xcor+l*cos(heading*pi/180); }
ycor:=ycor+l*sin(heading*0.01745329251994); { <-- ycor:=ycor+l*sin(heading*pi/180); }
{if pisac=true then begin
setcolor(brown);    }
(*       ZALACZYC TYLKO GDY MA RYSOWAC GDY SIE WRACA
line(x1,y1,round(xcor),round(ycor));
*)
{end;}
end;
procedure turtle;
begin
heading:=90;
xcor:=xturtle;
ycor:=yturtle;
end;

(*********** SubSubprocedures to paint fractal in Turtle graph **************)
                     (********* Platek Kocha **********)
procedure platek(st:shortint;b:real;t:byte;i:byte);
begin
inc(i);
if i=1  then t:=1;
if t=1  then begin
if st=0 then begin np(b); exit; end;
platek(st-1,b/3,t,i);
lw(60);
platek(st-1,b/3,t,i);
pw(120);
platek(st-1,b/3,t,i);
lw(60);
platek(st-1,b/3,t,i);
end;

if i=1  then begin lw(240); t:=2; end;
if t=2  then begin
if st=0 then begin np(b); exit; end;
platek(st-1,b/3,t,i);
lw(60);
platek(st-1,b/3,t,i);
pw(120);
platek(st-1,b/3,t,i);
lw(60);
platek(st-1,b/3,t,i);
end;

if i=1  then begin lw(240); t:=3; end;
if t=3  then begin
if st=0 then begin np(b); exit; end;
platek(st-1,b/3,t,i);
lw(60);
platek(st-1,b/3,t,i);
pw(120);
platek(st-1,b/3,t,i);
lw(60);
platek(st-1,b/3,t,i);
end;
end;

                       (******** Regular Tree ********)
procedure tree(st:integer;b:real);
var kat : byte;
procedure los;
begin
kat:=30;
end;
begin
if st=0 then begin k:=random(2); if k=0 then setcolor(lightgreen)
                                        else setcolor(green);
                                        np(b); exit; setcolor(brown); end;
np(b-(b*2/3));
los;
pw(kat);
tree(st-1,b-(b*1/2));
ws(b-(b*1/2));
lw(kat);
los;
lw(kat);
tree(st-1,b-(b*1/2));
ws(b-(b*1/2));
pw(kat);
tree(st-1,b-(b*2/3));
los;
lw(kat);
tree(st-1,b-(b*1/2));
ws(b-(b*1/2));
pw(kat);
los;
pw(kat);
tree(st-1,b-(b*1/2));
ws(b-(b*1/2));
lw(kat);
tree(st-1,b-(b*2/3));
end;

var value : byte;          { <--- dla zakresu kata, value:=trunc(b:real);}
             (********* Non-regular, random Tree *********)
procedure tree_rand(st:integer;bb:real);
var kat : byte;
procedure los;             { Proc do losowania galezi }
begin
kat:=random(value);
kat:=kat+value;
end;
begin
if st=0 then begin k:=random(2); if k=0 then setcolor(lightgreen)
                                        else setcolor(green);
                                        np(bb); exit; setcolor(brown); end;
np(bb-(bb*2/3));
los;
pw(kat);
tree_rand(st-1,bb-(bb*1/2));
ws(bb-(bb*1/2));
lw(kat);
los;
lw(kat);
tree_rand(st-1,bb-(bb*1/2));
ws(bb-(bb*1/2));
pw(kat);
tree_rand(st-1,bb-(bb*2/3));
los;
lw(kat);
tree_rand(st-1,bb-(bb*1/2));
ws(bb-(bb*1/2));
pw(kat);
los;
pw(kat);
tree_rand(st-1,bb-(bb*1/2));
ws(bb-(bb*1/2));
lw(kat);
tree_rand(st-1,bb-(bb*2/3));
end;
(*************** End of SubSubprocedures to paint fractals ******************)

begin
(*pisac:=false;                                             { <- only dla "ws" }*)
turtle;                                                 { Centrowanie zolwia }
setcolor(brown);
case frac of
7 : begin pw(180); tree(trunc(a),30*z); end;    { <------ Must be other !!!! }
8 : begin pw(180); tree(trunc(a),30*z); end;
9 : begin pw(180); value:=trunc(b*10); tree_rand(trunc(a),30*z); end;
10: begin setcolor(kolor); platek(trunc(a),10*z,0,0); end;
end;
end;
(******************** End of Subprocedure Turtle Graph **********************)


begin
if czysc=true then begin clearviewport; czysc:=false; end;
case frac of
1 : f1;               { Fractale na wzorach }
2 : f2;
3 : f3;
4 : f4;
5 : f5;
6 : paproc;
7..10: turtle_graph;  { Fractale w Turtle Graphics }
{9 : user def }
end;
end;
(******************** End of procedure to paint fractals ********************)



(******************************* M a i n ************************************)
begin
init;                                             { randomize i graph }
kolor:=white;                                     { Kolor malowania }
fraktal:=1;                                       { Pocz. Fractal }
jaki_frac:='Formula #1';
zmienne:=3;
a :=-pi;                                          { Stale wart dla Fract}
b := 9;     {9 19}
c := 1;     {7   }
x := 1;                                           { Pocz wart dla fract }
y := 1;
z := 5;                                           { Powiekszenie }
cleardevice;
setcolor(lightgray);
rectangle(2, 2, GetMaxy+3, GetMaxY-2);            { Mniejszy kwadrat }
rectangle(0, 0, getmaxx, getmaxy);                { Najwiekszy -//-  }
about;
status(true);

SetViewPort(3, 3, GetMaxy+2, GetMaxY-3, ClipOn);  { Ustalenie okna   }
xm:=getmaxy div 2+1;                              { Centrowanie fractala }
ym:=getmaxy div 2-2;                              { w oknie }
init_mouse;
repeat                                            { Petla do fract i po key }
status(true);           { Status wyk operacji (pracuje) }            { menu }

                     (***** Rysowanie fraktala *****)
rysuj_fraktal(fraktal);

status(false);          { czeka }
czytac:=true;           { Czy czytac klawisze dla "kursory" }
case kursory(1,4) of
1 : options;            { Podmenu opcje }
2 : colors;             { Kolory }
3 : help;               { About }
4 : koniec;
end;

until ch='&';           { Symboliczne wyjscie z petli }
end.